/* LED counter GNOME panel applet
 * Inspired by allPossibleImages for BeOS by Douglas Repetto.
 *
 * By Uwe Steinmann <Uwe.Steinmann@fernuni-hagen.de>
 *
 * Enjoy.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License  
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include <applet-widget.h>
#include <math.h>
#include "gtkdisplay.h"

#define DISPLAYS 3 
#define MAX_DISPLAYS 10
#define	BUTTON_HEIGHT	(15)
#define DISPLAY_WIDTH 51
#define	DISPLAY_HEIGHT 33
static int count_timer(GtkWidget *data);

typedef struct _DISP_INFO {
	GtkWidget *display;
	GtkWidget *label;
	guint digits;
	char *mailbox_file;
	int show_all_messages;
	int mail_mode;
	int front_end_mode;
	char *backend_command;
	char *exec_command;
	char *title;
} DISP_INFO;
DISP_INFO disp_info[MAX_DISPLAYS];

//guint64 x=0;
gint timeout;
GtkWidget *app;
int height, width;
int displays = DISPLAYS;
int new_displays = DISPLAYS;
int updatetime = 100000;
GdkColor on, off, over;
gchar con_s[32], coff_s[32], cover_s[32];

int check_vbox_messages (void);
int count_mail (char *file, int all);

GtkWidget *pb;

static void apply_cb(GtkObject *pb, gpointer p)
{
	GtkWidget *mailbox_s;
	guint8 r1, g1, b1, r2, g2, b2, i;
	char *buf;

	GnomeColorPicker *con = gtk_object_get_data(pb, "con");
	GnomeColorPicker *coff= gtk_object_get_data(pb, "coff");
	GnomeColorPicker *cover= gtk_object_get_data(pb, "cover");
	GtkWidget *width_s = gtk_object_get_data(GTK_OBJECT(pb),"width");
	GtkWidget *height_s = gtk_object_get_data(GTK_OBJECT(pb),"height");
	int update =
                GPOINTER_TO_INT(gtk_object_get_data(GTK_OBJECT(pb), "update"));

	int displays2 =
                GPOINTER_TO_INT(gtk_object_get_data(GTK_OBJECT(pb), "displays"));

	buf = gtk_entry_get_text(GTK_ENTRY(height_s));
	sscanf(buf, "%d", &height);
	buf = gtk_entry_get_text(GTK_ENTRY(width_s));
	sscanf(buf, "%d", &width);
	buf = gtk_entry_get_text(GTK_ENTRY(displays2));
	sscanf(buf, "%d", &new_displays);
	buf = gtk_entry_get_text(GTK_ENTRY(update));
	sscanf(buf, "%d", &updatetime);

//fprintf(stderr, "height = %d, width = %d, updatetime = %d\n", height, width, updatetime);
	for(i=0; i<displays; i++) {
		char buffer[256];

		sprintf(buffer, "digits%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		buf = gtk_entry_get_text(GTK_ENTRY(mailbox_s));
		sscanf(buf, "%d", &disp_info[i].digits);
		gtk_display_set_digits(GTK_DISPLAY(disp_info[i].display), disp_info[i].digits);

		gtk_widget_set_usize(disp_info[i].display, width*disp_info[i].digits, height);

		sprintf(buffer, "mailbox%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		if(disp_info[i].mailbox_file) {
			free(disp_info[i].mailbox_file);
			disp_info[i].mailbox_file = NULL;
		}
		disp_info[i].mailbox_file = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

		sprintf(buffer, "exec%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		if(disp_info[i].exec_command) {
			free(disp_info[i].exec_command);
		}
		disp_info[i].exec_command = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

		sprintf(buffer, "title%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		if(disp_info[i].title) {
			free(disp_info[i].title);
		}
		disp_info[i].title = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));
		gtk_label_set(GTK_LABEL(disp_info[i].label), disp_info[i].title);

		sprintf(buffer, "backend%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		if(disp_info[i].backend_command) {
			free(disp_info[i].backend_command);
		}
		disp_info[i].backend_command = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

		sprintf(buffer, "mailmode%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		disp_info[i].mail_mode = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 1 : 0;
		disp_info[i].front_end_mode = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 0 : 1;

		sprintf(buffer, "unreadmessages%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		disp_info[i].show_all_messages = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 0 : 1;

	}

	gnome_color_picker_get_i8(con,  &r1, &g1, &b1, NULL);
	g_snprintf(con_s, 31, "#%02X%02X%02X", r1, g1, b1);

	gnome_color_picker_get_i8(coff, &r2, &g2, &b2, NULL);
	g_snprintf(coff_s, 31, "#%02X%02X%02X", r2, g2, b2);
	
	gnome_color_picker_get_i8(cover, &r2, &g2, &b2, NULL);
	g_snprintf(cover_s, 31, "#%02X%02X%02X", r2, g2, b2);

	gdk_color_parse(con_s, &on);
	gdk_color_parse(coff_s, &off);
	gdk_color_parse(cover_s, &over);

	for(i = 0; i < displays; i++)
		gtk_display_set_colors(GTK_DISPLAY(disp_info[i].display), &on, &off, &over);

	gtk_timeout_remove(timeout);
	count_timer(NULL);
	timeout = gtk_timeout_add(updatetime, (GtkFunction)count_timer, NULL);
}

static void
changed_cb(GtkWidget *w, GtkWidget *d)
{	
	gnome_property_box_changed(GNOME_PROPERTY_BOX(pb));
}

static void
prefs_cb(GtkWidget *w, gpointer p)
{
	GtkWidget *table, *radio_table, *mail_table, *t_button, *b_button, *frame;
	GtkWidget *label, *heightw, *widthw, *con, *coff, *cover, *displays2, *update, *ww, *box;
	GtkAdjustment *adj;
	char buffer[50];
	int i, fr, fg, fb;

	pb = gnome_property_box_new();
	gtk_window_set_title(GTK_WINDOW(pb), _("Counter Properties"));
	
	table = gtk_table_new(7, 3, FALSE);

	/* On color */
	label = gtk_label_new(_("LED on color"));
	con = gnome_color_picker_new();
	sscanf( con_s, "#%02x%02x%02x", &fr,&fg,&fb );
	gnome_color_picker_set_i8(GNOME_COLOR_PICKER(con),
	                           fr,
	                           fg,
	                           fb,
	                           255);
	gtk_object_set_data(GTK_OBJECT(pb), "con", con);
	gtk_signal_connect(GTK_OBJECT(con), "color_set",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 0, 1);
	gtk_table_attach_defaults(GTK_TABLE(table), con, 2, 3, 0, 1);

	/* off color */
	label = gtk_label_new(_("LED off color"));
	coff = gnome_color_picker_new();
	sscanf( coff_s, "#%02x%02x%02x", &fr,&fg,&fb );
	gnome_color_picker_set_i8(GNOME_COLOR_PICKER(coff),
	                           fr,
	                           fg,
	                           fb,
	                           255);
	gtk_object_set_data(GTK_OBJECT(pb), "coff", coff);
	gtk_signal_connect(GTK_OBJECT(coff), "color_set",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 1, 2);
	gtk_table_attach_defaults(GTK_TABLE(table), coff,  2, 3, 1, 2);
	
	/* Over color */
	label = gtk_label_new(_("Overflow color"));
	cover = gnome_color_picker_new();
	sscanf( cover_s, "#%02x%02x%02x", &fr,&fg,&fb );
	gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cover),
	                           fr,
	                           fg,
	                           fb,
	                           255);
	gtk_object_set_data(GTK_OBJECT(pb), "cover", cover);
	gtk_signal_connect(GTK_OBJECT(cover), "color_set",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 2, 3);
	gtk_table_attach_defaults(GTK_TABLE(table), cover, 2, 3, 2, 3);

	/* height */
	label = gtk_label_new(_("Digit height"));
	heightw = gtk_entry_new_with_max_length(4);
	g_snprintf(buffer, sizeof(buffer), "%d", height);
	gtk_entry_set_text(GTK_ENTRY(heightw), (gchar *) buffer);
	gtk_object_set_data(GTK_OBJECT(pb), "height", heightw);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 3, 4);
	gtk_table_attach_defaults(GTK_TABLE(table), heightw,  2, 3, 3, 4);

	gtk_signal_connect(GTK_OBJECT(heightw), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), NULL);

	/* Width */
	label = gtk_label_new(_("Digit width"));
	widthw = gtk_entry_new_with_max_length(4);
	g_snprintf(buffer, sizeof(buffer), "%d", width);
	gtk_entry_set_text(GTK_ENTRY(widthw), (gchar *) buffer);
	gtk_object_set_data(GTK_OBJECT(pb), "width", widthw);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 4, 5);
	gtk_table_attach_defaults(GTK_TABLE(table), widthw,  2, 3, 4, 5);

	gtk_signal_connect(GTK_OBJECT(widthw), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), NULL);

	gnome_property_box_append_page(GNOME_PROPERTY_BOX(pb), table,
				       gtk_label_new(_("General")));

	/* number of displays */
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 1, MAX_DISPLAYS, 1, 1, 0);
	gtk_adjustment_set_value(adj, new_displays);
	label = gtk_label_new(_("Number of counters"));
	displays2 = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(pb), "displays", displays2);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 5, 6);
	gtk_table_attach_defaults(GTK_TABLE(table), displays2,  2, 3, 5, 6);

	gtk_signal_connect(GTK_OBJECT(displays2), "changed",
	                   GTK_SIGNAL_FUNC(changed_cb), NULL);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
	                   GTK_SIGNAL_FUNC(changed_cb), NULL);

	/* update */
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 0, 1000000, 100, 10, 0);
	gtk_adjustment_set_value(adj, updatetime);
	label = gtk_label_new(_("Update (ms)"));
	update = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(pb), "update", update);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 6, 7);
	gtk_table_attach_defaults(GTK_TABLE(table), update,  2, 3, 6, 7);

	gtk_signal_connect(GTK_OBJECT(adj), "changed",
	                   GTK_SIGNAL_FUNC(changed_cb), NULL);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
	                   GTK_SIGNAL_FUNC(changed_cb), NULL);

	for(i=0; i<displays; i++) {
		char buffer[40];
		GtkWidget *mail_filename, *entry;
		mail_table = gtk_table_new(7, 3, FALSE);

		label = gtk_label_new(_("Title"));
		entry = gtk_entry_new();
		gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info[i].title);
		sprintf(buffer, "title%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, entry);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 0, 1);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), entry,  1, 3, 0, 1);
		gtk_signal_connect(GTK_OBJECT(entry), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Mailbox"));
		box = gtk_hbox_new(FALSE,GNOME_PAD_SMALL);
		ww = gnome_file_entry_new("execute",_("Browse"));
		gtk_box_pack_start(GTK_BOX(box),ww,TRUE,TRUE,0);
		mail_filename = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (ww));
		gtk_entry_set_text(GTK_ENTRY(mail_filename), (gchar *) disp_info[i].mailbox_file);
		sprintf(buffer, "mailbox%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, mail_filename);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 2, 3);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), box,  1, 3, 2, 3);
		gtk_signal_connect(GTK_OBJECT(mail_filename), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Execute"));
		entry = gtk_entry_new();
		gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info[i].exec_command);
		sprintf(buffer, "exec%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, entry);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 5, 6);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), entry,  1, 3, 5, 6);
		gtk_signal_connect(GTK_OBJECT(entry), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Backend command"));
		entry = gtk_entry_new();
		gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info[i].backend_command);
		sprintf(buffer, "backend%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, entry);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 4, 5);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), entry,  1, 3, 4, 5);
		gtk_signal_connect(GTK_OBJECT(entry), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Counting"));
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 3, 4);
		frame = gtk_hbox_new (FALSE, 0);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), frame, 1, 3, 3, 4);
		radio_table = gtk_table_new(1, 2, TRUE);
		gtk_container_add (GTK_CONTAINER (frame), radio_table);
		t_button = gtk_radio_button_new_with_label (NULL, _("Count unread messages"));
		sprintf(buffer, "unreadmessages%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, t_button);
		gtk_table_attach(GTK_TABLE(radio_table), t_button, 0, 1, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
		b_button = gtk_radio_button_new_with_label (gtk_radio_button_group (GTK_RADIO_BUTTON (t_button)), _("Count all messages"));
		gtk_table_attach(GTK_TABLE(radio_table), b_button, 1, 2, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
		if(disp_info[i].show_all_messages)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_button), TRUE);
		else
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(t_button), TRUE);
		gtk_signal_connect(GTK_OBJECT(t_button), "toggled",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Mode"));
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 1, 2);
		frame = gtk_hbox_new (FALSE, 0);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), frame, 1, 3, 1, 2);
		radio_table = gtk_table_new(1, 2, TRUE);
		gtk_container_add (GTK_CONTAINER (frame), radio_table);
		t_button = gtk_radio_button_new_with_label (NULL, _("Mail"));
		sprintf(buffer, "mailmode%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, t_button);
		gtk_table_attach(GTK_TABLE(radio_table), t_button, 0, 1, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
		b_button = gtk_radio_button_new_with_label (gtk_radio_button_group (GTK_RADIO_BUTTON (t_button)), _("Command"));
		gtk_table_attach(GTK_TABLE(radio_table), b_button, 1, 2, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
		if(disp_info[i].mail_mode)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(t_button), TRUE);
		else
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_button), TRUE);
		gtk_signal_connect(GTK_OBJECT(t_button), "toggled",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		/* number of digits */
		adj = (GtkAdjustment *) gtk_adjustment_new(disp_info[i].digits, 1, MAX_DIGITS, 1, 1, 0);
		gtk_adjustment_set_value(adj, disp_info[i].digits);
		label = gtk_label_new(_("Number of digits"));
		displays2 = gtk_spin_button_new(adj, 0, 0);
		sprintf(buffer, "digits%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, displays2);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 6, 7);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), displays2,  1, 2, 6, 7);

		gtk_signal_connect(GTK_OBJECT(displays2), "changed",
	                   	GTK_SIGNAL_FUNC(changed_cb), NULL);
		gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
	                   	GTK_SIGNAL_FUNC(changed_cb), NULL);

		sprintf(buffer, _("Display %d"), i+1);
		gnome_property_box_append_page(GNOME_PROPERTY_BOX(pb), mail_table,
				       gtk_label_new(buffer));
	}

	gtk_signal_connect(GTK_OBJECT(pb), "apply",
                           GTK_SIGNAL_FUNC(apply_cb), pb);
	gtk_signal_connect(GTK_OBJECT(pb), "destroy",
                           GTK_SIGNAL_FUNC(gtk_widget_destroyed),&pb);

	gtk_widget_show_all(pb);
}

static void
about_cb(GtkWidget *w, gpointer d)
{
	gchar *authors[4];
	GtkWidget *about;
	
	authors[0] = "Uwe Steinmann";
	authors[1] = _("Insprired by Sixtyfour bit counter by Tim Gerla");
	authors[2] = _("and xled by Jan Schoenepauck <schoenep@uni-wuppertal.de>");
	authors[3] = _("and Joachim Gassen <gassen@uni-muenster.de>");
	authors[4] = NULL;
	
	about = gnome_about_new (
		"LED Counter",
		VERSION,
		"(C) 1999 Uwe Steinmann",
		(const gchar**)authors,
		_("This is a general purpose counter. It displays the counted number"
      " on an old fashion 7 segment display. It can count mail messages"
      " or simple display the return value of any command, making"
	    " it possible to count almost everything."
		  " Since the return value can not be greater than 255 it's"
		  " not always very useful, but I'm working on it."
		  " The number of displays is limited to 10 with a maximum of 10 digits."),
		NULL);
	
	gtk_widget_show(about);
	
	return;
}

static int
count_timer(GtkWidget *data)
{
	gint z;
	gint count = 0;

 	for(z = 0; z < displays; z++) {
		if (disp_info[z].mail_mode) {
			count = count_mail(disp_info[z].mailbox_file, disp_info[z].show_all_messages);
		} else if (disp_info[z].front_end_mode) {
			count = system(disp_info[z].backend_command)>>8;
		} else
			count = check_vbox_messages();

		gtk_display_set_value(GTK_DISPLAY(disp_info[z].display), count);
	}

	return 1;
}

gint run_command(GtkWidget *widget, gpointer data) {
  DISP_INFO   *disp_info;

	disp_info = (DISP_INFO *) data;
	if(disp_info->exec_command)
		system(disp_info->exec_command);

	return 0;
}

static GtkWidget
*create_counter(void)
{
	int x, y, i;
	GtkWidget *table, *button, *vbox, *hbox;
	GNOME_Panel_OrientType orient;
	
	gdk_color_parse(coff_s, &off);
	gdk_color_parse(con_s, &on);
	gdk_color_parse(cover_s, &over);

	orient = applet_widget_get_panel_orient (APPLET_WIDGET (app));
	switch (orient) {
		case GNOME_Panel_ORIENT_LEFT:
		case GNOME_Panel_ORIENT_RIGHT:
			table = gtk_table_new(displays, 1, FALSE);
			gtk_table_set_row_spacings(GTK_TABLE(table), GNOME_PAD_SMALL);
			break;
		default:
			table = gtk_table_new(1, displays, FALSE);
			gtk_table_set_col_spacings(GTK_TABLE(table), GNOME_PAD_SMALL);
			break;
	}

	x = y = 0;
	for(i = 0; i < displays; i++)
	{
		vbox = gtk_vbox_new(FALSE, 0);

		disp_info[i].display = gtk_display_new_with_digits(disp_info[i].digits);
		gtk_table_attach_defaults(GTK_TABLE(table),
					  vbox,
					  x, x+1, y, y+1);
		gtk_display_set_colors(GTK_DISPLAY(disp_info[i].display), &on, &off, &over);
		gtk_widget_set_usize(disp_info[i].display, width*disp_info[i].digits, height);
		gtk_box_pack_start(GTK_BOX(vbox), disp_info[i].display, TRUE, TRUE, 0);
//		gtk_widget_show(disp_info[i].display);
	
		button = gtk_button_new();
		gtk_signal_connect(GTK_OBJECT(button), "clicked",
	         	GTK_SIGNAL_FUNC(run_command),
	         	&disp_info[i]);
		gtk_widget_set_usize(button, 1, BUTTON_HEIGHT);
//		pixmap = gnome_stock_pixmap_widget(button,GNOME_STOCK_PIXMAP_MAIL);
		disp_info[i].label = gtk_label_new(disp_info[i].title);
		hbox  = gtk_hbox_new(FALSE, GNOME_PAD_SMALL/2);
//		gtk_box_pack_start(GTK_BOX(hbox),pixmap,FALSE,FALSE,0);
		gtk_box_pack_start(GTK_BOX(hbox),disp_info[i].label,TRUE,TRUE,0);
		gtk_container_add(GTK_CONTAINER(button),hbox);

		gtk_box_pack_start(GTK_BOX(vbox), button, TRUE, TRUE, 0);

		switch (orient) {
			case GNOME_Panel_ORIENT_LEFT:
			case GNOME_Panel_ORIENT_RIGHT:
				y++;
				break;
			default:
				x++;
				break;
		}
	}

//	gtk_widget_show_all(vbox);
	gtk_widget_show_all(table);
	return table;
}

static void
bye(GtkWidget *w, gpointer p)
{
	int i;
	char buffer[300];

	gnome_config_set_int("ledcount/general/displays", new_displays);
	gnome_config_set_int("ledcount/general/update", updatetime);
	gnome_config_set_int("ledcount/general/width", width);
	gnome_config_set_int("ledcount/general/height", height);
	sprintf(buffer, "ledcount/general/color_on");
	gnome_config_set_string(buffer, con_s);
	sprintf(buffer, "ledcount/general/color_off");
	gnome_config_set_string(buffer, coff_s);
	sprintf(buffer, "ledcount/general/color_over");
	gnome_config_set_string(buffer, cover_s);
	for(i=0; i<displays; i++) {
		sprintf(buffer, "ledcount/general/mailbox%d", i+1);
		gnome_config_set_string(buffer, disp_info[i].mailbox_file);
		sprintf(buffer, "ledcount/general/execute%d", i+1);
		gnome_config_set_string(buffer, disp_info[i].exec_command);
		sprintf(buffer, "ledcount/general/title%d", i+1);
		gnome_config_set_string(buffer, disp_info[i].title);
		sprintf(buffer, "ledcount/general/backend%d", i+1);
		gnome_config_set_string(buffer, disp_info[i].backend_command);
		sprintf(buffer, "ledcount/general/digits%d", i+1);
		gnome_config_set_int(buffer, disp_info[i].digits);
		sprintf(buffer, "ledcount/general/mailmode%d", i+1);
		gnome_config_set_int(buffer, disp_info[i].mail_mode);
		sprintf(buffer, "ledcount/general/showall%d", i+1);
		gnome_config_set_int(buffer, disp_info[i].show_all_messages);
		sprintf(buffer, "ledcount/general/frontendmode%d", i+1);
		gnome_config_set_int(buffer, disp_info[i].front_end_mode);
	}
	gnome_config_sync();
	gnome_config_drop_all();
	applet_widget_gtk_main_quit();
}

static int
save_session(GtkWidget *w, gpointer p)
{
	int i;
	char buffer[300];

	gnome_config_set_int("ledcount/general/displays", new_displays);
	gnome_config_set_int("ledcount/general/update", updatetime);
	gnome_config_set_int("ledcount/general/width", width);
	gnome_config_set_int("ledcount/general/height", height);
	sprintf(buffer, "ledcount/general/color_on");
	gnome_config_set_string(buffer, con_s);
	sprintf(buffer, "ledcount/general/color_off");
	gnome_config_set_string(buffer, coff_s);
	sprintf(buffer, "ledcount/general/color_over");
	gnome_config_set_string(buffer, cover_s);
	for(i=0; i<displays; i++) {
		sprintf(buffer, "ledcount/general/mailbox%d", i+1);
		gnome_config_set_string(buffer, disp_info[i].mailbox_file);
		sprintf(buffer, "ledcount/general/execute%d", i+1);
		gnome_config_set_string(buffer, disp_info[i].exec_command);
		sprintf(buffer, "ledcount/general/title%d", i+1);
		gnome_config_set_string(buffer, disp_info[i].title);
		sprintf(buffer, "ledcount/general/backend%d", i+1);
		gnome_config_set_string(buffer, disp_info[i].backend_command);
		sprintf(buffer, "ledcount/general/digits%d", i+1);
		gnome_config_set_int(buffer, disp_info[i].digits);
		sprintf(buffer, "ledcount/general/mailmode%d", i+1);
		gnome_config_set_int(buffer, disp_info[i].mail_mode);
		sprintf(buffer, "ledcount/general/showall%d", i+1);
		gnome_config_set_int(buffer, disp_info[i].show_all_messages);
		sprintf(buffer, "ledcount/general/frontendmode%d", i+1);
		gnome_config_set_int(buffer, disp_info[i].front_end_mode);
	}
	gnome_config_sync();
	gnome_config_drop_all();
	return FALSE;
}

int
main(int argc, char *argv[])
{
	GtkWidget *counter;
	int i;
	
	/* initialize the i18n stuff */
	textdomain (PACKAGE);
	bindtextdomain (PACKAGE, GNOMELOCALEDIR);

	applet_widget_init("ledcount_applet", VERSION, argc, argv, NULL, 0, NULL);
	
	for(i = 0; i < MAX_DISPLAYS; i++)
	{
		disp_info[i].mail_mode = 1;
		disp_info[i].front_end_mode = 0;
		disp_info[i].show_all_messages = 0;
		disp_info[i].mailbox_file = NULL;
		disp_info[i].front_end_mode = 0;
		disp_info[i].exec_command = NULL;
		disp_info[i].title = NULL;
		disp_info[i].digits = 3;
	}

	app = applet_widget_new("ledcount_applet");
	displays = gnome_config_get_int("ledcount/general/displays=1");
	if(displays > MAX_DISPLAYS)
		displays = MAX_DISPLAYS;
	new_displays = displays;
	updatetime = gnome_config_get_int("ledcount/general/update=100000");
	width = gnome_config_get_int("ledcount/general/width=51");
	height = gnome_config_get_int("ledcount/general/height=30");
	sprintf(con_s, "%s", gnome_config_get_string("ledcount/general/color_on=#FF1710"));
	sprintf(coff_s, "%s", gnome_config_get_string("ledcount/general/color_off=#400000"));
	sprintf(cover_s, "%s", gnome_config_get_string("ledcount/general/color_over=#17FF00"));

	for(i=0; i<displays; i++) {
// FIXME: maybe we have to use strdup here because apply_cb frees the memory
		char buffer[50];
		sprintf(buffer, "ledcount/general/mailbox%d=", i+1);
		disp_info[i].mailbox_file = gnome_config_get_string(buffer);
		sprintf(buffer, "ledcount/general/execute%d=", i+1);
		disp_info[i].exec_command = gnome_config_get_string(buffer);
		sprintf(buffer, "ledcount/general/title%d=%d", i+1, i+1);
		disp_info[i].title = gnome_config_get_string(buffer);
		sprintf(buffer, "ledcount/general/backend%d=", i+1);
		disp_info[i].backend_command = gnome_config_get_string(buffer);
		sprintf(buffer, "ledcount/general/digits%d=3", i+1);
		disp_info[i].digits = gnome_config_get_int(buffer);
		sprintf(buffer, "ledcount/general/mailmode%d=1", i+1);
		disp_info[i].mail_mode = gnome_config_get_int(buffer);
		sprintf(buffer, "ledcount/general/showall%d=0", i+1);
		disp_info[i].show_all_messages = gnome_config_get_int(buffer);
		sprintf(buffer, "ledcount/general/frontendmode%d=0", i+1);
		disp_info[i].front_end_mode = gnome_config_get_int(buffer);
//fprintf(stderr, "mailmode = %d, front_end_mode = %d\n", disp_info[i].mail_mode, disp_info[i].front_end_mode);
	}

	if(!app)
		g_error("Cannot create ledcount applet!");

	counter = create_counter();
	applet_widget_add(APPLET_WIDGET(app), counter);
	gtk_widget_show(app);

	gtk_signal_connect(GTK_OBJECT(app), "delete_event",
			   GTK_SIGNAL_FUNC(bye), NULL);
	gtk_signal_connect(GTK_OBJECT(app), "save_session",
			   GTK_SIGNAL_FUNC(save_session), NULL);


	applet_widget_register_stock_callback(APPLET_WIDGET(app),
					      "about",                    
					      GNOME_STOCK_MENU_ABOUT,
					      _("About"),         
					      GTK_SIGNAL_FUNC(about_cb),
					      NULL);

	applet_widget_register_stock_callback(APPLET_WIDGET(app),
					      "preference",                    
					      GNOME_STOCK_MENU_PREF,
					      _("Preferences"),         
					      GTK_SIGNAL_FUNC(prefs_cb),
					      NULL);

	count_timer(NULL);
	timeout = gtk_timeout_add(updatetime, (GtkFunction)count_timer, NULL);
	
	applet_widget_gtk_main();
	return(0);
}
