#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <errno.h>
#include <signal.h>
#include <dirent.h>
#include <sys/stat.h>

static char *incoming_dir;
static int show_all_messages;

/* this function is based on the fact that the x flag of the messages
   is being toggled when the messages have been played by vbox. */

int check_vbox_messages (void) {
  struct dirent *dir_info;
  DIR *dir;
  int count=0;
  struct stat stat_buf;
  char file_name[PATH_MAX+1];
  dir = opendir (incoming_dir);
  if (dir == NULL) return (-1);
  dir_info = readdir (dir);
  while (dir_info != NULL) {
    sprintf(file_name,"%s/%s",incoming_dir,dir_info->d_name);
    if ((dir_info->d_name[0]!='.')&&(stat (file_name,&stat_buf) >= 0)) {
      if (show_all_messages) {
        if (stat_buf.st_mode&S_IREAD) count ++;
      } else
        if ((stat_buf.st_mode&S_IREAD)&&!(stat_buf.st_mode&S_IXUSR)) count ++;
    }
    dir_info = readdir (dir);
  }
  closedir(dir);
  return (count);
}

#if 0
static int count_occurences (FILE *file, char *exp) {
  char buf[1024];
  int len, matches;
  len = strlen(exp);	
  matches = 0;
  while ( fgets(buf, 1024, file) != NULL) {
    if ( strncmp(buf, exp, len) == 0 ) 
      matches++;
  }
  rewind(file);
  return ( matches );
}
#endif

#define FROMSTR "From "
#define STATUSSTR "Status: R"
#define DATESTR "Date: "
static int count_all_mails (FILE *file, int *from, int *status) {
  char buf[1024], buf1[1024];
  int len1, len2, len3, endheader, founddate;
  len1 = strlen(FROMSTR);	
  len2 = strlen(STATUSSTR);	
  len3 = strlen(DATESTR);	
  *from = 0;
  *status = 0;
  endheader = 0;
  founddate = 0;
  while ( fgets(buf, 1024, file) != NULL) {
    if ( buf[0] == '\n' ) {
      endheader = 1;
      founddate = 0;
      }
    else { /* First look for FROMSTR */
      if ( ( strncmp(buf, FROMSTR, len1) == 0 ) &&
           ( strchr(buf, ':' ) != NULL ) ) {
        endheader = 0;
        strncpy(buf1, buf, 1024);
        }
      else { /* Don't increment from unless there is a DATASTR in header */
        if ( ( strncmp(buf, DATESTR, len3) == 0 ) &&
             ( endheader == 0 ) ) {
          (*from)++;
          founddate = 1;
          }
        else {
          if ( ( strncmp(buf, STATUSSTR, len2) == 0 ) &&
               ( endheader == 0 ) ) {
            if(founddate == 0) {
              fprintf(stderr, "Found Header, Status but no Date\n");
              fprintf(stderr, buf1);
            }
            else {
              (*status)++;
            }
          }
        }
      }
    }
  }
  rewind(file);
  return ( *from - *status );
}
#undef FROMSTR
#undef STATUSSTR

/* Test and open the mailbox file -- hang on the mailbox if -f */
static FILE * open_mailbox_file (char * file) {
  FILE *mailbox = NULL;    
  char * errmsg;
  if((NULL == file) || ((mailbox = fopen(file, "r")) == NULL)) {
    errmsg = malloc((strlen("xled: ") + strlen(file) + 1) * sizeof(char));
    sprintf(errmsg, "xled: %s", file);
    perror(errmsg);
  }
  return (mailbox);
} 
/* Subtract messages from messages w/ a "status:" line to get new messages */
int count_mail (char *file, int all) {
  int From, Status, Diff;
  FILE *F;
  if(NULL == file)
    return(998);
	if(file[0] == '\0')
		return(997);
  F=open_mailbox_file (file);
  if(NULL == F)
    return(999);
/*  From = count_occurences(F, "From "); */
/*  Status = count_occurences(F, "Status: R"); */
  Diff = count_all_mails(F, &From, &Status);
  fclose (F);
/*  return (all?From:(From - Status));*/
  return (all?From:Diff);
}


